﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using HarmonyLib;
using UnityEngine;

public class ValExtract : Mod
{
    private Traverse tr;
    private List<string> ObjectFieldsList;
    static ValExtract instance;

    private void Start()
    {
        instance = this;

        Debug.Log("ValExtract loaded!");
    }

    private void invokeMethod(string[] args)
    {
        bool flag = args.Length != 2;
        if (flag)
        {
            Debug.LogError("Wrong Syntax! Expected: invokeMethod className methodName");
        }
        else
        {
            Type type = ValExtract.getTypeByName(args[0])[0];
            type.GetMethod(args[1]).Invoke(UnityEngine.Object.FindObjectOfType(type), new object[0]);
        }
    }

    private void printVariablesOf(string[] args)
    {
        string text = args[0];
        Type[] typeByName = ValExtract.getTypeByName(text);
        bool flag = typeByName.Count<Type>() <= 0;
        if (flag)
        {
            Debug.LogError("[ValExtract] Couldn't find class " + text);
        }
        else
        {
            bool flag2 = typeByName.Count<Type>() > 1;
            if (flag2)
            {
                Debug.LogWarning("[ValExtract] Found more than one class with that name. Will resume to only search the first one.");
            }
            object[] array = UnityEngine.Object.FindObjectsOfType(typeByName[0]);
            object[] array2 = array;
            bool flag3 = array2.Length == 0;
            if (flag3)
            {
                Debug.LogError("[ValExtract] Can't find instance of an Object from the type " + typeByName[0]);
            }
            else
            {
                for (int i = 0; i < array2.Length; i++)
                {
                    bool flag4 = array2.Length > 1;
                    if (flag4)
                    {
                        Debug.LogWarning(string.Concat(new object[]
                        {
                            "[ValExtract] There is more than one instance of objects of type ",
                            typeByName[0],
                            " contiuing with number ",
                            i
                        }));
                    }
                    object obj = array2[i];
                    tr = Traverse.Create(obj);
                    ObjectFieldsList = tr.Fields();
                    bool flag5 = args.Length > 1;
                    if (flag5)
                    {
                        for (int j = 1; j < args.Length; j++)
                        {
                            foreach (string text2 in ObjectFieldsList)
                            {
                                bool flag6 = text2 == args[j];
                                if (flag6)
                                {
                                    Debug.Log("[ValExtract] Found Field: " + text2);
                                    ObjectFieldsList = tr.Field(text2).Fields();
                                    tr = Traverse.Create(tr.Field(text2).GetValue());
                                    break;
                                }
                            }
                        }
                    }
                    Debug.Log("<color=green>" + args[args.Length - 1] + "</color>");
                    foreach (string text3 in ObjectFieldsList)
                    {
                        try
                        {
                            Debug.Log(text3 + ": " + tr.Field(text3).ToString());
                        }
                        catch (Exception arg)
                        {
                            Debug.LogError("3: " + arg);
                        }
                    }
                }
            }
        }
    }

    public static Type[] getTypeByName(string className)
    {
        List<Type> list = new List<Type>();
        foreach (Assembly assembly in AppDomain.CurrentDomain.GetAssemblies())
        {
            Type[] types = assembly.GetTypes();
            for (int j = 0; j < types.Length; j++)
            {
                bool flag = types[j].Name == className;
                if (flag)
                {
                    list.Add(types[j]);
                }
            }
        }
        return list.ToArray();
    }

    public void OnModUnload()
    {
        Debug.Log("ValExtract has been unloaded!");
        UnityEngine.Object.Destroy(base.gameObject);
    }

    [ConsoleCommand(name: "returnVariablesOf", docs: "Returns all values of datatypes a given class has.")]
    public static void MyCommand(string[] args)
    {
        instance.printVariablesOf(args);
    }
}